//	}bsO[h̃eXg

#include <windows.h>
#include <tchar.h>

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
//	200*200̕ᎆ`
void mesh_draw(HDC hdc,HPEN hPen1,HPEN hPen2);

TCHAR szClassNme[] = TEXT("MapMode");

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInst,TCHAR* lpszCmdLine, int nCmdShow){
	HWND hWnd;
	MSG lpMsg;
	WNDCLASS myProg;

	if (!hPreInst) {
		myProg.style =CS_HREDRAW | CS_VREDRAW;
		myProg.lpfnWndProc =WndProc;
		myProg.cbClsExtra =0;
		myProg.cbWndExtra =0;
		myProg.hInstance =hInstance;
		myProg.hIcon =NULL;
		myProg.hCursor =LoadCursor(NULL, IDC_ARROW);
		myProg.hbrBackground =(HBRUSH)GetStockObject(WHITE_BRUSH);
		myProg.lpszMenuName =NULL;
		myProg.lpszClassName =szClassNme;
		if (!RegisterClass(&myProg))
			return FALSE;
	}
	hWnd = CreateWindow(szClassNme,
	szClassNme,
	WS_OVERLAPPEDWINDOW,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	NULL,
	NULL,
	hInstance,
	NULL);
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	while (GetMessage(&lpMsg, NULL, 0, 0)) {
		TranslateMessage(&lpMsg);
		DispatchMessage(&lpMsg);
	}
	return int(lpMsg.wParam);
}


LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	HDC hdc;
	PAINTSTRUCT ps;

	switch (msg) {
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		case WM_PAINT:{
			hdc = BeginPaint(hWnd, &ps);
			HPEN hPen1,hPen2;
			hPen1 = CreatePen(PS_SOLID, 1, RGB(0, 0, 255));
			hPen2 = CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
			HBRUSH hBrush = CreateHatchBrush(HS_DIAGCROSS, RGB(0, 255, 0));
			SelectObject(hdc, hBrush);
			//	}bsO[hKpO̐}``
			mesh_draw(hdc,hPen1,hPen2);
			//	P[OE_ݒ
			SetMapMode(hdc,MM_ANISOTROPIC);
			SetWindowExtEx(hdc,1000,1000,NULL);
			SetViewportExtEx(hdc,500,500,NULL);
			SetViewportOrgEx(hdc,50,30,NULL);
			//	}bsO[hKp̐}``
			mesh_draw(hdc,hPen1,hPen2);
			DeleteObject(hPen1);
			DeleteObject(hPen2);
			DeleteObject(hBrush);
			EndPaint(hWnd, &ps);
			break;}
		default:
			return(DefWindowProc(hWnd, msg, wParam, lParam));
	}
	return (0L);
}

//	200*200̕ᎆ`

void mesh_draw(HDC hdc,HPEN hPen1,HPEN hPen2){
	int x,y;
	TCHAR buf[8];
	for(x=0;x<=200;){
		if(( x % 100)==0)
			SelectObject(hdc, hPen2);
		else
			SelectObject(hdc, hPen1);
		MoveToEx(hdc,x,0,NULL);
		LineTo(hdc,x,200);
		x+=20;
	}
	for(y=0;y<=200;){
		if(( y % 100)==0)
			SelectObject(hdc, hPen2);
		else
			SelectObject(hdc, hPen1);
		MoveToEx(hdc,0,y,NULL);
		LineTo(hdc,200,y);
		y+=20;
	}
	SelectObject(hdc, hPen2);
	for(x=100;x<=200;){
		TCHAR buf[16];
		wsprintf(buf,_TEXT("%d"),x);
		TextOut(hdc , x-10 , 203 , buf , (int)_tcslen(buf));
		x+=100;
	}
	for(y=100;y<200;){
		wsprintf(buf,_TEXT("%d"),y);
		TextOut(hdc , 202 , y-10 , buf , (int)_tcslen(buf));
		y+=100;
	}
	Ellipse(hdc,0,150,50,200);
	Rectangle(hdc,120,160,160,180);
}
